/*  jQuery.ma.mapa  v1.0  */
(function ($) {
    $.widget('ui.mapaMA', (function () {
        var directionsService = new google.maps.DirectionsService();
        
        var map;
        var marcadores_activos = [];
        var self;
        var limites = new google.maps.LatLngBounds();
		var infowindow;
        var caminho = [];
        return {
            options: {
				mapa:true,
				direccoes:true,
				imprimir:true,
                altura: '100',
                largura: '100',
                percentagem: true,
                lat: 40.44057,
                lng: -8.433927,
				innershadow:true,
                enableControls: true,
				directionsboxID:'directionsboxMA',
				directionsID: 'directionsMA',
                imgFolder: '/images/mapa',
                pinsDiferentes: true,
                abrePopups:true,
				especial:false,
				textos:{ 
					procurar: 'Coimbra', 
					origem:'Origem', 
					destino: 'Destino', 
					botao:'Procurar', 
					definirdestino:'Definir como destino',
					naoencontrou: 'N&atilde;o foram encontrados caminhos',
					infoTrajecto: 'Informa&ccedil;&atilde;o do trajecto',
					distancia: 'Dist&acirc;cia',
                    duracao:'Tempo'
	            },   
				rotaOptions:{
					corlinha:'#2A4C43',
					modoAvancado: false
				},
                mapOptions: {
                    //center: new google.maps.LatLng(lat,lng),
                    zoom: 10,
                    mapTypeId: google.maps.MapTypeId.ROADMAP,
                    mapTypeControl: true,
                    mapTypeControlOptions: {},
                    panControl: true,
                    panControlOptions: {},
                    zoomControl: true,
                    zoomControlOptions: {},
                    streetViewControl: false,
                    scrollwheel: true,
                    disableDefaultUI: false,
                    minZoom: 5,
                    maxZoom: 15
                }, 
                customControls: false,
                marcadores: []
            },
			/* ------ CRIA MAPA -----------------------------------------------------------------------------------------*/
            _create: function () {
                self = this;
               
                infowindow = new google.maps.InfoWindow();
				
				if(self.options.mapa){
					
					//cria a sombra
					if (self.options.innershadow){ 
						self.adicionaSombra();
						$(self.element[0]).css("position", "relative");
						$(self.element[0]).css("display", "block");	
					}

					$(this.element[0]).append('<div id="mapaMA"></div>')
					
				//	simbolo = this.options.percentagem ? "%" : "";
					
					//define o tamanho do componente todo
					this.element.css("width",this.options.largura);
					this.element.height("100%");
					
					//define o tamanho do mapa
					$("#mapaMA").css("height",this.options.altura);
					$("#mapaMA").width("100%");
					
					//inicia o mapa
					 map = new google.maps.Map($("#mapaMA")[0], this.options.mapOptions);
					 map.setCenter(new google.maps.LatLng(this.options.lat, this.options.lng));
					 map.setZoom(self.options.mapOptions.zoom);
                 }
				 
				if(self.options.direccoes){
					if (this.options.enableControls) this._createControls();
				}
                //if (this.options.customControls) this._mapCustomControls();
                
				  if(this.options.marcadores.length>0) this._criaMarcadores();
            },
				/* ADICIONA SOMBRA AO MAPA */
				adicionaSombra: function(){
				//simbolo = this.options.percentagem ? "%" : "px";
				
				a =this.options.altura;//+simbolo;
				l ="400px"//this.options.largura;//+simbolo;
			
				$(this.element[0]).append('<div id="sombra"><div id="ds"><div id="ds_h"><div class="ds hh1 o1" style="width:'+l+'"></div><div class="ds hh2 o2" style="width:'+l+'"></div><div class="ds hh3 o3" style="width: '+l+'"></div><div class="ds hh4 o4" style="width: '+l+'"></div><div class="ds hh5 o5" style="width: '+l+'"></div></div><div id="ds_v"><div class="ds v1 o1" style="height: '+a+'"></div><div class="ds v2 o2" style="height: '+a+'"></div><div class="ds v3 o3" style="height: '+a+'"></div><div class="ds v4 o4" style="height: '+a+'"></div><div class="ds v5 o5" style="height: '+a+'"></div></div></div></div>');
			},
            /* CONTROLOS DO MAPA CUSTOMIZADOS */
            _mapCustomControls: function () {
                var controls = $('<div id="controls_mapa" />').appendTo(document.body);
                var controls_topo = $('<div id="controlo_topo" />').appendTo(controls)
                var controls_slider = $('<div id="controlo_slider" />').appendTo(controls);
                $(iconMapa("cima")).css({top: '15px',left: '40px'}).click(function () { map.panBy(0, -150);}).appendTo(controls_topo);
                $(iconMapa("esquerda")).css({top: '40px',left: '15px'}).click(function () {map.panBy(-150, 0);}).appendTo(controls_topo);
                $(iconMapa("direita")).css({top: '40px',left: '65px'}).click(function () {map.panBy(150, 0);}).appendTo(controls_topo);
                $(iconMapa("baixo")).css({top: '65px',left: '40px'}).click(function () {map.panBy(0, 150);}).appendTo(controls_topo);
                $(iconMapa("mais")).css({top: '0px',left: '0px'}).click(function () {map.setZoom(map.getZoom() + 1);$("#map-slider").slider("value", map.getZoom());}).appendTo(controls_slider);
                $(iconMapa("menos")).css({top: '224px',left: '0px'}).click(function () {map.setZoom(map.getZoom() - 1);$("#map-slider").slider("value", map.getZoom());}).appendTo(controls_slider);
                var zoomChanged = false;
                $('<div id="map-slider" />').height(170).slider({
                    orientation: "vertical",
                    min: this.options.mapOptions.minZoom,
                    max: this.options.mapOptions.maxZoom,
                    step: 1,
                    value: map.getZoom(),
                    stop: function () {
                        map.setZoom($(this).slider("value"));
                    }
                }).css({
                    top: '55px',
                    left: '0px',
                    position: 'absolute'
                }).appendTo(controls_slider);
                google.maps.event.addListener(map, "zoom_changed", function () {
                    zoomChanged = true;
                    $("#map-slider").slider("value", map.getZoom());
                });
                map.controls[google.maps.ControlPosition.TOP_LEFT].push(controls[0]);

                function iconMapa(tipo) {
                    switch (tipo) {
						case "cima": iconClass = 'mapa-cima';break;
						case "baixo": iconClass = 'mapa-baixo';break;
						case "esquerda": iconClass = 'mapa-esquerda'; break;
						case "direita": iconClass = 'mapa-direita'; break;
						case "mais": iconClass = 'mapa-mais'; break;
						case "menos": iconClass = 'mapa-menos'; break;
						case "fecha": iconClass = 'mapa-fecha'; break;
                    }
                    return '<div class="mapa-icon ' + iconClass + '"></div>';
                }
            },
			_createControls: function(){
			
				if (this.options.directionsboxID == 'directionsboxMA') {
						$(this.element[0]).append('<div id="directionsboxMA"></div>')
				}

				if (this.options.directionsID == 'directionsMA') {
						$(this.element[0]).append('<div id="directionsMA"></div>')
				}
				
				$("#" + this.options.directionsboxID + "").append('<div id="directions-sel-MA"></div>');
				$("#directions-sel-MA").append('<div id="origem-mapa-MA"><input id="origemMAPA" class="input-map-MA" type="text" value="'+self.options.textos.procurar+'" onfocus="this.select()" name="origem"></div>');

				if(self.options.marcadores.length>1){ $("#directions-sel-MA").append('<div id="destino-mapa-MA"><select id="destinoMAPA"></select></div>')};

				$("#origem-mapa-MA").append('<div id="botao-mapa-MA" style="cursor:pointer; cursro:hand;">' + self.options.textos.botao + '</div>');
						
				$("#botao-mapa-MA").click(function(){
					if($("#origemMAPA").val()!="" || $("#origemMAPA").val()!=self.options.textos.procurar)
						self._criaRota();
				});
				
				$('#origemMAPA').bind('keypress', function(e) {
					e.SuppressKeyPress = true;
					if(e.keyCode==13){
						if($("#origemMAPA").val()!="" || $("#origemMAPA").val()!=self.options.textos.procurar)
						self._criaRota();
					}
			});
				
				if(self.options.imprimir){
				
					$("#options-mapa-print-MA").live("click", function(){
					
						var mywindow = window.open('', 'PrintRota', 'height=600,width=540,scrollbars=1,location=0,status=0,menubar=0');
						mywindow.document.write('<html><head><title>Print Directions</title>');
						mywindow.document.write('<link rel="stylesheet" href="/css/jquery.ma.mapa.simple.css" type="text/css" />');
						mywindow.document.write('<style>body{font-size:12px; font-family:arial} #options-mapa-print-MA,#options-mapa-close-MA{display:none!important}</style>');
						mywindow.document.write('</head><body ><a onclick="print();"><img src="/images/mapa/imprimir.png"/></a>');
						mywindow.document.write($("#"+self.options.directionsID).html());
						mywindow.document.write('</body></html>');
						mywindow.document.close();
						mywindow.print();
					});
				}
				$("#options-mapa-close-MA").live("click", function(){
					self._reset();
					self._criaMarcadores();	
				});
				
				$("#clicapop").live("click", function(){
					 $("#destinoMAPA").val($(this).attr("value"));
				});
			},
			_createModoAvancado: function(){
			
				$("#" + this.options.directionsboxID + "").append('<div id="avancado-mapa-MA">Modo Avancado</div>');
			
			},
			
            _reset: function () { 
                for (var h = marcadores_activos.length - 1; h >= 0; h--) {
                    marcadores_activos[h].marker.setMap(null);
                }
                $(".pto_check").attr('checked', false);
                $(".control_check").css('background-position', "top");
				
				self.apagaRota();
                marcadores_activos = [];
				limites = new google.maps.LatLngBounds();
				
				$("#options-mapa-close-MA").hide();
				$("#options-mapa-print-MA").hide();
				$("#dir_erro").hide();
            },            

			/*-----   INICIO DAS FUNCOES DOS MARCADORES     --------------------------------------------------------------*/
			
			_criaMarcadores: function () {
                self = this;
				var op="";
				
                for (var i = 0; i < this.options.marcadores.length; i++) {
                    var marcador = self.options.marcadores[i];
                    self._adicionaMarcador(marcador);
					op += '<option value="' + marcador.id + '">' + marcador.titulo + '</option>';	
                }
				if (self.options.mapa){
					if(this.options.marcadores.length==1){ map.panTo(new google.maps.LatLng(self.options.marcadores[0].lat, self.options.marcadores[0].lng))}else{ map.fitBounds(limites);};
				}
				if(this.options.marcadores.length>1) $("#destinoMAPA").html(op);
				
            },
            //ADICIONA UM DETERMINADO MARCADOR
            _adicionaMarcador: function (marcador) {
                    var marker = this._constroiMarcador(new google.maps.LatLng(marcador.lat, marcador.lng), marcador.titulo, marcador.estado)
                    if (this.options.abrePopups)
                        this.adicionaListenerMarcador(marker, marcador);  
					if(this.options.especial)
						this.adicionaAccaoMarcador(marker, marcador); 
            },
            //CONSTROI O MARCADOR
            _constroiMarcador: function (point,titulo,id) {
                var pin = this.getPinImg(id);
                marker = new google.maps.Marker({
                    position: point,
                    icon: pin,
                    map: map,
                    title: titulo//,
                  //  animation: google.maps.Animation.DROP
                });
                limites.extend(marker.getPosition());
				
                self.guardaMarcador(id, marker);
				return marker;
            },
            //DEVOLVE O ICON DO MARCADOR CONSOANTE O ID
            getPinImg: function (id) {
			
				if(!self.options.pinsDiferentes && id) id =0;
				if(id==undefined) id ="origem";
                return new google.maps.MarkerImage(this.options.imgFolder + '/pin_'+id+'.png');
            },
            //GUARDA O MARCADOR NO ARRAY DE MARCADORES ACTIVOS
            guardaMarcador: function (id, marker) {
                marcadores_activos.push({
                    "id": id,
                    "marker": marker
                });
            },
            /* ADICIONA OS LISTENERS A CADA MARKER */
            adicionaListenerMarcador: function (marker, marcador) {
			
                 google.maps.event.addListener(marker, 'click', (function (marker, marcador) {
                     return function () {
						infowindow.close();
						frame = '<div id="popup-mapa-MA">'+marcador.conteudo+'</div>';
						
						if(self.options.marcadores.length>1)
						frame += '<p id="clicapop" value="'+ marcador.id +'">'+self.options.textos.definirdestino+'  <img src="/images/mapa/pin_0.png" alt="" width="12px" height="16px" style="border:0px;vertical-align:middle;padding-bottom:3px;" /></p>';                
                        
						infowindow.setContent(frame);
                        infowindow.open(map, this);
                    }
                 })(marker, marcador));

            },
			adicionaAccaoMarcador: function (marker, marcador) {
			
                 google.maps.event.addListener(marker, 'click', (function (marker, marcador) {
                     return function () {
					 
						//$("#listagem").animate({left:-748},"fast");
						
						$("#show").animate({left:100},"fast",function(){
							
							document.getElementById('show_frame').setAttribute('src', '/empreendimentos/show.aspx?idcont='+marcador.id);
							$("#show_frame").load(function (){

								$("#listagem").animate({left:-748},"fast");
								$("#show").animate({left:-748},"fast");
								
								if ($.browser.msie && parseInt($.browser.version, 10) == 9) {
									if($(window).width()>1280)
										$(".largura_base").css("width","1280px;");
									else
										$(".largura_base").css("width","980px;");
								}
							});
						});
                    }
                 })(marker, marcador));

            },
            
			/*-----   INICIO DAS FUNCOES DAS ROTAS     --------------------------------------------------------------------*/

			_criaRota:function(){
				
				var origem = $("#origemMAPA").val();
								
				if(self.options.marcadores.length>1){
				
					for(var i=0; i<self.options.marcadores.length; i++){
						if(self.options.marcadores[i].id == $("#destinoMAPA").val()) var id_dest=i;
					}
				}else{
					var id_dest = 0;
				}
				var destino =  new google.maps.LatLng(self.options.marcadores[id_dest].lat, self.options.marcadores[id_dest].lng);
				
				if (origem != "") {
				   var request = {
					   origin: origem,
					   destination: destino,
					   travelMode: google.maps.DirectionsTravelMode.DRIVING
				   };
				    
				   directionsService.route(request, function (response, status) {
					   if (status == google.maps.DirectionsStatus.OK) {
							
							self._reset();
					   
						    var legs = response.routes[0].legs;
							var legsTam = legs.length;
							var fim;
							for (i = 0; i < legsTam; i++) {
								var steps = legs[i].steps;
								for (var step = 0; step < steps.length; step++) {
									polylineOptions = {
										map: map,
										strokeColor: self.options.rotaOptions.corlinha,
										strokeOpacity: .8,
										strokeWeight: 4,
										path: steps[step].lat_lngs
									}
									fim = steps[step].end_location;	
									var linha = new google.maps.Polyline(polylineOptions);
									caminho.push(linha);
								}
								
								instrucoes ="";
								instrucoes += "<div id='directions-topo-mapaMA'><img src='"+self.options.imgFolder+"/pin_origem.png' height=26 width=20 style='vertical-align:middle; padding-right:10px'/>"+legs[i].start_address+"</div>"
								instrucoes += "<div id='directions-meio-mapaMA'>";

								instrucoes += "<div class='d_linha header'>";
								instrucoes += "<div class='d_id'>&nbsp;</div>";
								instrucoes += "<div class='d_desc'>" + self.options.textos.infoTrajecto + " </div>";
								instrucoes += "<div class='d_dist'><b>" + self.options.textos.distancia + ":</b> " + legs[i].distance.text + " <b>" + self.options.textos.tempo + ":</b> " + legs[i].duration.text + "</div>";
								instrucoes += "</div>"


								
								for(var k=0; k<legs[i].steps.length; k++){
									instrucoes +="<div class='d_linha'>";
									instrucoes +="<div class='d_id'>"+(k+1)+"</div>";
									instrucoes +="<div class='d_desc'>"+legs[i].steps[k].instructions+"</div>";
									instrucoes +="<div class='d_dist'>"+legs[i].steps[k].distance.text+"</div>";
									instrucoes +="</div>"
								}

								instrucoes += "</div>";
								instrucoes += "<div id='directions-fundo-mapaMA'><img src='"+self.options.imgFolder+"/pin_0.png' height=26 width=20 style='vertical-align:middle; padding-right:10px'/>"+legs[i].end_address+" - "+ self.options.marcadores[id_dest].titulo+"</div>"
							}
							
							$("#" + self.options.directionsID + "").append(instrucoes);

							$("#directions-topo-mapaMA").append('<div id="options-mapa-MA" style="cursor:pointer;cursor:hand;"></div<');
							
							if(self.options.imprimir) {
								$("#options-mapa-MA").append('<div id="options-mapa-print-MA"><img src="'+ self.options.imgFolder+'/imprimir.png" style="vertical-align:middle" border="0" alt="" /></div>');
							}
							
							$("#options-mapa-MA").append('<div id="options-mapa-close-MA"><img src="'+ self.options.imgFolder+'/fechar.png" style="vertical-align:middle" border="0" alt="" /></div>');
							
							if(self.options.mapa){
								self._constroiMarcador(response.routes[0].legs[0].steps[0].start_location, self.options.textos.origem);
								self._constroiMarcador(fim, self.options.marcadores[id_dest].titulo, 0);
								
								map.fitBounds(limites);
							}
							$("#options-mapa-close-MA").show();
							$("#options-mapa-print-MA").show();
					   } else {
					   
						if($("#dir_erro").length==0)
							$("#" + self.options.directionsID + "").append('<div id="dir_erro" style="clear:both;padding-top:5px; padding-left:5px;padding-bottom:5px;">'+self.options.textos.naoencontrou+'</div>');
						else
							$("#dir_erro").html(self.options.textos.naoencontrou);

					   }
				   });
			   }
			   else {
				   alert('Campo de origem invlido.');
			   }
			},
            //APAGA DETERMINADA ROTA DO MAPA
            apagaRota: function () {
                for (var c = 0; c < caminho.length; c++) {
                    caminho[c].setMap(null);
                }
                caminho = []; 
				
				$("#" + this.options.directionsID + "").html("");
            },

            /********************* public functions *********************/
            refresh: function () {
                //reload with existing week
                // this._loadCalEvents(this.element.data('startDate'));
            },
            /*
             * Clear all events currently loaded into the calendar
             */
            clear: function () {
                //this._clearCalendar();
            }
        }; // end of widget function return
    })() //end of widget function closure execution
    ); // end of $.widget("ui.weekCalendar"...
})(jQuery);